<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  
  <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
  <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1, minimum-scale=1, user-scalable=no, minimal-ui">
  <meta name="renderer" content="webkit">
  <meta http-equiv="Cache-Control" content="no-transform" />
  <meta http-equiv="Cache-Control" content="no-siteapp" />
  <meta name="apple-mobile-web-app-capable" content="yes">
  <meta name="apple-mobile-web-app-status-bar-style" content="black">
  <meta name="format-detection" content="telephone=no,email=no,adress=no">
  <!-- Color theme for statusbar -->
  <meta name="theme-color" content="#000000" />
  <!-- 强制页面在当前窗口以独立页面显示,防止别人在框架里调用页面 -->
  <meta http-equiv="window-target" content="_top" />
  
  
  <title>has_and_belongs_to_many tutorial | Hashmi Mohammed</title>
  <meta name="description" content="### Implementing has_and_belongs_to_many association in Rails3A has_and_belongs_to_many association directly creates a many-to-many connection between models. This blog will illustrate how to implemen">
<meta property="og:type" content="article">
<meta property="og:title" content="has_and_belongs_to_many tutorial">
<meta property="og:url" content="http://hashmi.smf.gitlab.io/2017/03/18/has-and-belongs-to-many-tutorial/index.html">
<meta property="og:site_name" content="Hashmi Mohammed">
<meta property="og:description" content="### Implementing has_and_belongs_to_many association in Rails3A has_and_belongs_to_many association directly creates a many-to-many connection between models. This blog will illustrate how to implemen">
<meta property="og:updated_time" content="2017-12-14T07:49:18.276Z">
<meta name="twitter:card" content="summary">
<meta name="twitter:title" content="has_and_belongs_to_many tutorial">
<meta name="twitter:description" content="### Implementing has_and_belongs_to_many association in Rails3A has_and_belongs_to_many association directly creates a many-to-many connection between models. This blog will illustrate how to implemen">
  <!-- Canonical links -->
  <link rel="canonical" href="http://hashmi.smf.gitlab.io/2017/03/18/has-and-belongs-to-many-tutorial/index.html">
  
  
    <link rel="icon" href="/favicon.png" type="image/x-icon">
  
  <link rel="stylesheet" href="/css/style.css">
  
  
  
  
</head>


<body class="main-center theme-blue" itemscope itemtype="http://schema.org/WebPage">
  <header class="header" itemscope itemtype="http://schema.org/WPHeader">
  <div class="slimContent">
    <div class="navbar-header">
      
      
      <div class="profile-block text-center">
        <a id="avatar" href="https://github.com/hashmee" target="_blank">
          <img class="img-circle img-rotate" src="/images/avatar.jpg" width="200" height="200">
        </a>
        <h2 id="name" class="hidden-xs hidden-sm">Hashmi Mohammed</h2>
        <h3 id="title" class="hidden-xs hidden-sm hidden-md">Ardent Programmer</h3>
        <small id="location" class="text-muted hidden-xs hidden-sm"><i class="icon icon-map-marker"></i> Hyderabad, India</small>
      </div>
      
      <div class="search" id="search-form-wrap">

    <form class="search-form sidebar-form">
        <div class="input-group">
            <input type="text" class="search-form-input form-control" placeholder="Search" />
            <span class="input-group-btn">
                <button type="submit" class="search-form-submit btn btn-flat" onclick="return false;"><i class="icon icon-search"></i></button>
            </span>
        </div>
    </form>
    <div class="ins-search">
  <div class="ins-search-mask"></div>
  <div class="ins-search-container">
    <div class="ins-input-wrapper">
      <input type="text" class="ins-search-input" placeholder="Type something..." x-webkit-speech />
      <button type="button" class="close ins-close ins-selectable" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">×</span></button>
    </div>
    <div class="ins-section-wrapper">
      <div class="ins-section-container"></div>
    </div>
  </div>
</div>


</div>
      <button class="navbar-toggle collapsed" type="button" data-toggle="collapse" data-target="#main-navbar" aria-controls="main-navbar" aria-expanded="false">
        <span class="sr-only">Toggle navigation</span>
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
      </button>
    </div>
    <nav id="main-navbar" class="collapse navbar-collapse" itemscope itemtype="http://schema.org/SiteNavigationElement" role="navigation">
      <ul class="nav navbar-nav main-nav ">
        
        
        <li class="menu-item menu-item-home">
          <a href="/.">
            
            <i class="icon icon-home-fill"></i>
            
            <span class="menu-title">Home</span>
          </a>
        </li>
        
        
        <li class="menu-item menu-item-about">
          <a href="/about">
            
            <i class="icon icon-cup-fill"></i>
            
            <span class="menu-title">About</span>
          </a>
        </li>
        
        
        <li class="menu-item menu-item-archives">
          <a href="/archives">
            
            <i class="icon icon-archives-fill"></i>
            
            <span class="menu-title">Archives</span>
          </a>
        </li>
        
      </ul>
      
	
    <ul class="social-links">
    	
        <li><a href="https://github.com/hashmee" target="_blank" title="Github" data-toggle=tooltip data-placement=top><i class="icon icon-github"></i></a></li>
        
        <li><a href="https://twitter.com/hashmi_smf" target="_blank" title="Twitter" data-toggle=tooltip data-placement=top><i class="icon icon-twitter"></i></a></li>
        
    </ul>

    </nav>
  </div>
</header>

  
    <aside class="sidebar" itemscope itemtype="http://schema.org/WPSideBar">
  <div class="slimContent">
    
      <div class="widget">
    <h3 class="widget-title">Board</h3>
    <div class="widget-body">
        <div id="board">
            <div class="content">
                <p>I Blog new and interesting things(which I feel :)) in a programmer point of view.</p>
            </div>
        </div>
    </div>
</div>

    
      

    
      
  <div class="widget">
    <h3 class="widget-title">Tags</h3>
    <div class="widget-body">
      <ul class="tag-list"><li class="tag-list-item"><a class="tag-list-link" href="/tags/active-record-transactions/">active record transactions</a><span class="tag-list-count">1</span></li><li class="tag-list-item"><a class="tag-list-link" href="/tags/angular-html-templates/">angular html templates</a><span class="tag-list-count">1</span></li><li class="tag-list-item"><a class="tag-list-link" href="/tags/dotfiles/">dotfiles</a><span class="tag-list-count">1</span></li><li class="tag-list-item"><a class="tag-list-link" href="/tags/firstpost/">firstpost</a><span class="tag-list-count">1</span></li><li class="tag-list-item"><a class="tag-list-link" href="/tags/react-redux-youtube-api-search/">react, redux, youtube_api_search</a><span class="tag-list-count">1</span></li></ul>
    </div>
  </div>


    
      
  <div class="widget">
    <h3 class="widget-title">Tag Cloud</h3>
    <div class="widget-body tagcloud">
      <a href="/tags/active-record-transactions/" style="font-size: 13px;">active record transactions</a> <a href="/tags/angular-html-templates/" style="font-size: 13px;">angular html templates</a> <a href="/tags/dotfiles/" style="font-size: 13px;">dotfiles</a> <a href="/tags/firstpost/" style="font-size: 13px;">firstpost</a> <a href="/tags/react-redux-youtube-api-search/" style="font-size: 13px;">react, redux, youtube_api_search</a>
    </div>
  </div>

    
      
  <div class="widget">
    <h3 class="widget-title">Archive</h3>
    <div class="widget-body">
      <ul class="archive-list"><li class="archive-list-item"><a class="archive-list-link" href="/archives/2018/01/">January 2018</a><span class="archive-list-count">2</span></li><li class="archive-list-item"><a class="archive-list-link" href="/archives/2017/12/">December 2017</a><span class="archive-list-count">1</span></li><li class="archive-list-item"><a class="archive-list-link" href="/archives/2017/11/">November 2017</a><span class="archive-list-count">2</span></li><li class="archive-list-item"><a class="archive-list-link" href="/archives/2017/10/">October 2017</a><span class="archive-list-count">2</span></li><li class="archive-list-item"><a class="archive-list-link" href="/archives/2017/06/">June 2017</a><span class="archive-list-count">4</span></li><li class="archive-list-item"><a class="archive-list-link" href="/archives/2017/05/">May 2017</a><span class="archive-list-count">3</span></li><li class="archive-list-item"><a class="archive-list-link" href="/archives/2017/03/">March 2017</a><span class="archive-list-count">1</span></li><li class="archive-list-item"><a class="archive-list-link" href="/archives/2015/06/">June 2015</a><span class="archive-list-count">1</span></li><li class="archive-list-item"><a class="archive-list-link" href="/archives/2014/12/">December 2014</a><span class="archive-list-count">1</span></li></ul>
    </div>
  </div>


    
      
  <div class="widget">
    <h3 class="widget-title">Recent Posts</h3>
    <div class="widget-body">
      <ul class="recent-post-list list-unstyled no-thumbnail">
        
          <li>
            
            <div class="item-inner">
              <p class="item-category">
                
              </p>
              <p class="item-title">
                <a href="/2018/01/17/react-redux-learning/" class="title">react_redux_learning</a>
              </p>
              <p class="item-date">
                <time datetime="2018-01-17T03:58:46.000Z" itemprop="datePublished">2018-01-17</time>
              </p>
            </div>
          </li>
          
          <li>
            
            <div class="item-inner">
              <p class="item-category">
                
              </p>
              <p class="item-title">
                <a href="/2018/01/09/my_dotfiles/" class="title">Dotfiles for my dev environment</a>
              </p>
              <p class="item-date">
                <time datetime="2018-01-08T19:30:06.000Z" itemprop="datePublished">2018-01-09</time>
              </p>
            </div>
          </li>
          
          <li>
            
            <div class="item-inner">
              <p class="item-category">
                
              </p>
              <p class="item-title">
                <a href="/2017/12/14/awesome-post/" class="title">Awesome post</a>
              </p>
              <p class="item-date">
                <time datetime="2017-12-13T19:20:06.000Z" itemprop="datePublished">2017-12-14</time>
              </p>
            </div>
          </li>
          
          <li>
            
            <div class="item-inner">
              <p class="item-category">
                
              </p>
              <p class="item-title">
                <a href="/2017/11/26/npm-json-server-for-random-api-with-loads-of-data/" class="title">npm json-server for random api with loads of data</a>
              </p>
              <p class="item-date">
                <time datetime="2017-11-25T18:39:57.000Z" itemprop="datePublished">2017-11-26</time>
              </p>
            </div>
          </li>
          
          <li>
            
            <div class="item-inner">
              <p class="item-category">
                
              </p>
              <p class="item-title">
                <a href="/2017/11/25/Docker-build-Ruby-on-Rails/" class="title">Docker build Ruby on Rails</a>
              </p>
              <p class="item-date">
                <time datetime="2017-11-24T20:55:54.000Z" itemprop="datePublished">2017-11-25</time>
              </p>
            </div>
          </li>
          
      </ul>
    </div>
  </div>
  

    
  </div>
</aside>

  
  
<main class="main" role="main">
  <div class="content">
  <article id="post-has-and-belongs-to-many-tutorial" class="article article-type-post" itemscope itemtype="http://schema.org/BlogPosting">
    
    <div class="article-header">
      
        
  
    <h1 class="article-title" itemprop="name">
      has_and_belongs_to_many tutorial
    </h1>
  

      
      <div class="article-meta">
        <span class="article-date">
    <i class="icon icon-calendar-check"></i>
	<a href="/2017/03/18/has-and-belongs-to-many-tutorial/" class="article-date">
	  <time datetime="2017-03-17T22:10:31.000Z" itemprop="datePublished">2017-03-18</time>
	</a>
</span>
        
        

        

        <span class="post-comment"><i class="icon icon-comment"></i> <a href="/2017/03/18/has-and-belongs-to-many-tutorial/#comments" class="article-comment-link">Comments</a></span>
        
      </div>
    </div>
    <div class="article-entry marked-body" itemprop="articleBody">
      
        <div dir="ltr" style="text-align: left;" trbidi="on"><br><br>### Implementing has_and_belongs_to_many association in Rails3<br><div class="post-header" style="background-color: white; color: #4e2800; font-family: Arial, Tahoma, Helvetica, FreeSans, sans-serif; font-size: 13px; line-height: 1.6; margin: 0px 0px 1em;"><div class="post-header-line-1"></div></div><div class="post-body entry-content" id="post-body-9066792197596141403" itemprop="description articleBody" style="background-color: white; color: #4e2800; font-family: Arial, Tahoma, Helvetica, FreeSans, sans-serif; font-size: 13px; line-height: 1.4; position: relative; width: 586px;"><div dir="ltr" trbidi="on"><br><span style="font-family: Verdana, sans-serif;">A has_and_belongs_to_many association directly creates a many-to-many connection between models. This blog will illustrate how to implement such relation in Rails3 using this example - if an application includes two models :-<br>1. Event<br>2. Organizer<br>Here each Event can have many Organizers and each Organizer can appear in many Events.<br><br>Following are the required steps for implementing such relation :-</span><br><div><span style="font-family: Verdana, sans-serif;"><br>1. Generate the models using the command<br><strong>rails g model Organizer<br>rails g model Event</strong></span><br><div><span style="font-family: Verdana, sans-serif;"><strong>
</strong>Note: you can add necessary attributes to the models.<br><br>2. Declare the models in this way<br><br><strong>class Event &lt; ActiveRecord::Base</strong><br><strong>&nbsp; has_and_belongs_to_many :organizers&nbsp;</strong><span style="color: red;">#append this line to your model</span><br><strong>end</strong><br><br><strong>class Organizer &lt; ActiveRecord::Base</strong><br><strong>&nbsp; has_and_belongs_to_many :events &nbsp; &nbsp; &nbsp;&nbsp;</strong><span style="color: red;">#append this line to your model</span><br><strong>end</strong><br><br>3. On running&nbsp;<strong>rake db:migrate</strong>&nbsp;for these models, by default rails create a column&nbsp;<strong>id&nbsp;</strong>in its tables. So both Events and Organizers table will have an id column.<br><br>4. Generate a rails migration for creating the join table EventsOrganizers.</span></div><div><span style="font-family: Verdana, sans-serif;"><strong>rails g migration CreateEventsOrganizers</strong></span></div><div><span style="font-family: Verdana, sans-serif;"><strong>
</strong>Note: The join table name should have the name of the models in alphabetical order. Here Events come 1st and then Organizers<br><br>5. In the migration file created : “create_events_organizers.rb” , write the following code<br><br><strong>class CreateEventsOrganizers &lt; ActiveRecord::Migration<br>&nbsp; def change<br>&nbsp; &nbsp; create_table :events_organizers do |t|<br>&nbsp; &nbsp; &nbsp; t.integer :event_id<br>&nbsp; &nbsp; &nbsp; t.integer :organizer_id<br>&nbsp; &nbsp; end<br>&nbsp; end<br>end</strong><br><br>Note: Remove the timestamps (created by default) attribute since it will throw an error on create/edit of the association from the UI.<br><br>6. Run&nbsp;<strong>rake db:migrate&nbsp;</strong><br>This will create a table in your database:&nbsp;<strong>events_organizers</strong><br>Fields will be :&nbsp;<strong>id</strong>,&nbsp;<strong>event_id</strong>,&nbsp;<strong>organizer_id</strong><br><br>7. One has to give an option in the UI for adding multiple organizers to a particular event. So one can add the following code to create a multiple select drop-down for organizers in the view events/_form.html.erb file</span><span style="font-family: Verdana, sans-serif;"><strong>&lt;%= f.label :organizers %&gt;</strong></span><span style="font-family: Verdana, sans-serif;"><strong><br>&lt;%= select_tag “organizing_team”, options_from_collection_for_select(Organizer.all, ‘id’, ‘name’,@event.organizers.map{ |j| j.id }), :multiple =&gt; true %&gt;</strong><br><br>This code will display a drop-down with the names of already added organizers.<br><br>8. In the events_controller.rb file<br>append these lines to the create and update methods<br><br><strong>def create<br>@event = Event.new(params[:event])<br>@organizers = Organizer.where(:id =&gt; params[:organizing_team])<br>@event.</strong></span><strong><span style="font-family: Verdana, sans-serif;">organizers&nbsp;</span><span style="font-family: Verdana, sans-serif;">&lt;&lt; @organizers&nbsp;</span></strong></div><div><span style="font-family: Verdana, sans-serif;"><span style="color: red;">#associate the selected organizers to the event and create records in the join table</span></span><span style="font-family: Verdana, sans-serif;"><br><br><strong>def update<br>@event = Event.find(params[:id])<br>@organizers = Organizer.where(:id =&gt; params[:organizing_team])<br>@event.organizers.destroy_all &nbsp;&nbsp;</strong><span style="color: red;">#disassociate the already added organizers</span><br><strong>@event.organizers &lt;&lt; @organizers&nbsp;</strong></span></div><div><span style="color: red; font-family: Verdana, sans-serif;">#</span><span style="color: red; font-family: Verdana, sans-serif;">associate the selected organizers to the event and create records in the join table</span><span style="font-family: Verdana, sans-serif;"><br><br>9. On creation/update of an event when multiple organizers are selected then the entries are added to the join table&nbsp;<strong>events_organizers</strong></span></div></div></div></div></div>
      
    </div>
    <div class="article-footer">
      <blockquote class="mt-2x">
  <ul class="post-copyright list-unstyled">
    
    <li class="post-copyright-link hidden-xs">
      <strong>Link to this：</strong>
      <a href="http://hashmi.smf.gitlab.io/2017/03/18/has-and-belongs-to-many-tutorial/" title="has_and_belongs_to_many tutorial" target="_blank" rel="external">http://hashmi.smf.gitlab.io/2017/03/18/has-and-belongs-to-many-tutorial/</a>
    </li>
    
  </ul>
</blockquote>


<div class="panel panel-default panel-badger">
  <div class="panel-body">
    <figure class="media">
      <div class="media-left">
        <a href="https://github.com/hashmee" target="_blank" class="img-burn thumb-sm visible-lg">
          <img src="/images/avatar.jpg" class="img-rounded w-full" alt="">
        </a>
      </div>
      <div class="media-body">
        <h3 class="media-heading"><a href="https://github.com/hashmee" target="_blank"><span class="text-dark">Hashmi Mohammed</span><small class="ml-1x">Ardent Programmer</small></a></h3>
        <div>Going Happy</div>
      </div>
    </figure>
  </div>
</div>


    </div>
  </article>
  
    
  <section id="comments">
  	
      <div id="disqus_thread">
        <noscript>Please enable JavaScript to view the <a href="//disqus.com/?ref_noscript">comments powered by Disqus.</a></noscript>
      </div>
    
  </section>


  
</div>

  <nav class="bar bar-footer clearfix" data-stick-bottom>
  <div class="bar-inner">
  
  <ul class="pager pull-left">
    
    <li class="prev">
      <a href="/2017/05/07/Avoiding-git-push-by-giving-passwords-every-time/" title="Avoiding git push by giving passwords every time"><i class="icon icon-angle-left" aria-hidden="true"></i><span>&nbsp;&nbsp;Newer</span></a>
    </li>
    
    
    <li class="next">
      <a href="/2015/06/09/Some-ruby-on-rails/" title="Some ruby on rails"><span>Older&nbsp;&nbsp;</span><i class="icon icon-angle-right" aria-hidden="true"></i></a>
    </li>
    
    
  </ul>
  
  
  
  <div class="bar-right">
    
    <div class="share-component" data-sites="twitter" data-mobile-sites="weibo,qq,qzone"></div>
    
  </div>
  </div>
</nav>
  


</main>

  <footer class="footer" itemscope itemtype="http://schema.org/WPFooter">
	
	
    <ul class="social-links">
    	
        <li><a href="https://github.com/hashmee" target="_blank" title="Github" data-toggle=tooltip data-placement=top><i class="icon icon-github"></i></a></li>
        
        <li><a href="https://twitter.com/hashmi_smf" target="_blank" title="Twitter" data-toggle=tooltip data-placement=top><i class="icon icon-twitter"></i></a></li>
        
    </ul>

    <div class="copyright">
    	
        <div class="publishby">

        </div>
    </div>
</footer>

  <script src="//cdn.jsdelivr.net/npm/jquery@1.12.4/dist/jquery.min.js"></script>
<script>
window.jQuery || document.write('<script src="js/jquery.min.js"><\/script>')
</script>
<script src="/js/plugin.min.js"></script>
<script src="/js/application.js"></script>

    <script>
(function (window) {
    var INSIGHT_CONFIG = {
        TRANSLATION: {
            POSTS: 'Posts',
            PAGES: 'Pages',
            CATEGORIES: 'Categories',
            TAGS: 'Tags',
            UNTITLED: '(Untitled)',
        },
        ROOT_URL: '/',
        CONTENT_URL: '/content.json',
    };
    window.INSIGHT_CONFIG = INSIGHT_CONFIG;
})(window);
</script>
<script src="/js/insight.js"></script>





   




   
    
    <script defer>
    var disqus_config = function () {
        
            this.page.url = 'http://hashmi.smf.gitlab.io/2017/03/18/has-and-belongs-to-many-tutorial/';
        
        this.page.identifier = 'has-and-belongs-to-many-tutorial';
    };
    (function() { 
        var d = document, s = d.createElement('script');  
        s.src = '//' + 'mohammed-hashmi' + '.disqus.com/embed.js';
        s.setAttribute('data-timestamp', +new Date());
        (d.head || d.body).appendChild(s);
    })();
</script>






    <script defer type="text/javascript">
(function(i,s,o,g,r,a,m) {i['GoogleAnalyticsObject']=r;i[r]=i[r]||function() {
(i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
})(window,document,'script','//www.google-analytics.com/analytics.js','ga');

ga('create', 'UA-111202628-1', 'auto');
ga('send', 'pageview');

</script>



</body>
</html>